%A general scaling function. Scales all values by subtracting the minimum
%value, and divides by (max - min).
%
%scaled = scale(min, max, data)
%
%Inputs:
%
%min: The minimum value of the data. Must be specified, since min(data)
%might not be the actual minimum value you want to scale to.
%
%max: The max value of the data. Must be specified, since max(data)
%might not be the actual max value you want to scale to.
%
%data: The values that are to be scaled.
%
%Outputs:
%
%scaled: The scaled values.

function scaled = scale(min, max, data)

scaled = (data - min)/(max - min);