% Calculate the entropy of a dataset.
% function E = entropy(outputs)
%
% Inputs: A vector containing all the output class values for the dataset.
% Each element in the vector should be the output of one instance in the
% dataset.
%
% Output: The calculated entropy
function E = entropy(output)
    E = 0;
    for i = 1:size(output,2)
        num = size(output(output(:,i)==1),1);
        p = num/size(output,1);
        E = E-(p*log2(p));
    end    
