% Calculate the grouped input overlap for two sets of input vectors.
%
% function overlap = grouped_input_overlap(input)
%
% Inputs: 
% first_set: A matrix containing the input vectors in one training set.
%            Each row of the vector should contain one input vector.  
% second_set: A matrix containing the input vectors for the second training
% set.  This set should have the same format as first_set
%
% Outputs:
% overlap: The total input overlap for the dataset

function overlap = grouped_input_overlap(first_set, second_set)
    n = size(first_set,1)+size(second_set,1);
    overlap = total_grouped_orthogonality(first_set, second_set)/n;