%
% function max_gio = max_igo(first_set, second_set)
%
% Calculates the theoretical maximum grouped input overlap
% This is given as max_gio = (N*M)/(N+M) where N and M is the number of
% instances in first and second input set
%
% Inputs:
% first_set: The first input set. Each row in the matrix is one instance
% second_set: The second input set. Each row in the matrix is one instance
%
% Output: The theoretical max GIO
function max_gio = max_io(first_set, second_set)
    n = size(first_set,1);
    m = size(second_set,1);
    max_gio = (n*m)/(n+m);