% Calculate the level of orthogonality between vectors a and b. This is
% defined as the cosine of the angle between them/
%
% function ans = orthogonality(a, b)
%
% Inputs:
% a, b: Two vectors. length(a) must be equal to length(b)
%
% Output: cos(angle(norm(a),norm(b)))
function ans = orthogonality(a, b)
    norm_a = norm(a);
    if(norm_a==0)
        norm_a = 1;
    end
        
    norm_b = norm(b);
    if(norm_b==0)
        norm_b = 1;
    end
        
    ans = dot(a/norm_a, b/norm_b);