% Calculate the total gropued orthogonality between two sets of vectors as
% the summed cosine of the angle between any two vectors not in the same
% set. 
%
% function ans = total_grouped orthogonality(first_set, second_set)
%
% Inputs:
% first_set: A MxN matrix where each of the M rows contains an vector in
% N-dimensional space.
% second_set: A MxN matrix where each of the M rows contains an vector in
% N-dimensional space.
%
% Output: The summed orthogonality between any two vectors that are not in
% the same set
function ans = total_grouped_orthogonality(first_set, second_set)
    ans = 0;
    %TODO: Two nested for-loops is very far from being optimal in Matlab.
    %Some internal functions might help on getting this done faster.
    for i = 1 : size(first_set,1)
        first = first_set(i,:);
        for j = 1 : size(second_set,1)
            second = second_set(j, :);
            ans = ans+orthogonality(first, second);            
        end
    end
