if [ ! $# == 4 ]; then
    echo "Usage: $0 <number of datasets> <numer of instances> <percent of noise> <number of irrelevant attributes>"
    exit
fi

for i in `seq 1 $1`;
do
  #The program from the UCI repository only generates 17 irrelevant attributes,
  #so fail if more are requested
  if [ "$4" -gt 17 ]
  then
     echo "The maximum number of irrelevant attributes is 17, ${4} requested."
     exit
  fi

  #If no irrelevant attributes are requested, use the program that does not
  #make irrelevant attributes at all
  if [ "$4" = "0" ]
  then
      echo $4
      ./led $2 $RANDOM led7_${2}_${3}noise${i}.data $3

  #Otherwise use the program that creates 17 irrelevant attributes, and
  #remove extras later
  elif [ "$4" != "0" ]
  then
      #Calculate the number of total inputs
      num=`echo "24-(17-$4)" | bc -l` 
      #Create dataset with 17 random attributes
      ./led24 $2 $RANDOM tmp.data $3  
      #Remove 
      cut -d"," -f"1-${num},25" tmp.data > led${num}_${2}_${3}noise${i}.data
  fi
done
rm tmp.data