# Script for generating 20 datasets with 500 instances from an original dataset
# with 5000.  The script creates the datafiles waveform500_1.data to
# waveform500_20.data.  Each file contains 500 instances starting at a random
# point in the original file and moving forward.
for i in `seq 1 20`;
do
   #Generate a random number between 500 and 5000
   RAN_NUM=`echo "500+($RANDOM/32767)*4500"| bc -l | awk -F"." '{print $1}'`

   #Select the instances from RAN_NUM-500 to RAN_NUM
   cat waveform.data | tail -n $RAN_NUM | head -n 500 > waveform500_$i.data
done
