function [out] = analyze_cf_results(in_data, io_data, gio_data, ...
    check_point, plotlength, info_str)

    % A helper function for converting the data structure names
    % into names suitable for display in a plot
    function ans = replace_name(inp)
        if strcmp(inp, 'log_8')
            ans = '8 Psuedo patterns';
        elseif strcmp(inp,'log_32')
            ans = '32 Pseudo patterns';
        elseif strcmp(inp,'log_128')
            ans = '128 Pseudo patterns';
        elseif strcmp(inp,'log_500')
            ans = '500 Pseudo patterns';
        else
            ans = inp;
        end
    end

    hold off;
    data = orderfields(in_data);
    names = fieldnames(data);
    check_val= check_point;
    
 %   normal_best = find(normal.runs.avg.third.mean<halfval, 1, 'first');
 %   pseudo_res.best = -1;
    
    %Keep an array of names for the plot.
 %   plotnames = strvcat('Backpropagation', '50% Performance');
    
    %Loop for finding the best pseudo solution and for finding
    x_io = zeros(size(names));
    x_gio = zeros(size(names));
    epocs = zeros(size(names));
    x_irr = zeros(size(names));
    disp(sprintf('%s&IO&GIO&Epochs until 75% performance\\', info_str));
    for i=1:size(names)
        this_item = data.(char(names(i))).avg.third.mean;
        test_id = strrep(char(names(i)), 'log_', '');
        test_name = cat(2,'test_', test_id);
        out.(test_name).io = io_data.(cat(2,'io_',test_id)).percent;
        out.(test_name).gio = gio_data.(cat(2,'gio_',test_id)).percent;

        %plotnames = strvcat(plotnames, replace_name(char(names(i))));
        check_val = data.(char(names(i))).avg.first.mean(end)*check_point;
        at_checkpoint = find(this_item<check_val, 1, 'first');

        %Store where this test reached the check point
        out.(test_name).epoch = at_checkpoint;        

        disp(sprintf('%s&%2.1f&%2.1f&%d\\\\', test_id, out.(test_name).io, ...
            out.(test_name).gio, out.(test_name).epoch));
        x_irr(i) = str2num(test_id);
        x_io(i) = out.(test_name).io;
        x_gio(i) = out.(test_name).gio;
        epochs(i) = out.(test_name).epoch;
    end
end