function [first, second, third] = run_led_test(fname)
    
    % Set various experiment parameters
    epochs = 3000;
    learning_rate = 0.9;
    hidden_size = 40;
    criterion = 0.49;
    train_percentage = 0.7;
    test_percentage = 0.3;    
    
    [input,output] = read_led(fname);

    %Select one output class at random to use for second set
    second_output_class = floor(rand*10) + 1;
    
    %Create first set of instances
    indexes = output(:,second_output_class)==0;
    first.all.in = submatrix(input, indexes);
    first.all.out = submatrix(output, indexes);

    %Create second set of instances
    indexes = output(:,second_output_class)==1;
    second.all.in = submatrix(input, indexes);
    second.all.out = submatrix(output, indexes);

    %Run the experiment
    [first, second, third] = run_cf_experiment(first, second, ...
        train_percentage, test_percentage, epochs, learning_rate, ...
        hidden_size, criterion);