function [first, second, third] = run_waveform_test(fname)
    epochs = 1000;
    learning_rate = 0.2;
    hidden_size = 40;
    criterion = 0.49;
    train_percentage = 0.66;
    test_percentage = 0.33;
    
    [input,output] = read_waveform(fname);

    %Select one output class at random to use for second set
    second_output_class = floor(rand*3) + 1;
    indexes = output(:,second_output_class)==0;
    first.all.in = submatrix(input, indexes);
    first.all.out = submatrix(output, indexes);

    indexes = output(:,second_output_class)==1;
    second.all.in = submatrix(input, indexes);
    second.all.out = submatrix(output, indexes);
 
    [first, second, third] = run_cf_experiment(first, second, ...
        train_percentage, test_percentage, epochs, learning_rate, ...
        hidden_size, criterion);